import java.util.concurrent.BrokenBarrierException;
import java.util.concurrent.CyclicBarrier;
import java.util.Random;

public class Assemble implements Runnable {

    private CyclicBarrier waitForIt;
    private CyclicBarrier ready;
    private CyclicBarrier used;
    private Random        generator = new Random();

    public Assemble(CyclicBarrier waitForIt,
                    CyclicBarrier ready,
                    CyclicBarrier used) {
        this.waitForIt = waitForIt;
        this.ready     = ready;
        this.used      = used;
    }

    public void run() {
        try {
            waitForIt.await(); 
        } catch (InterruptedException ex) { 
        } catch (BrokenBarrierException ex) { 
        }

        while (true) {
            try {
                ready.await();
            } catch (InterruptedException ex) { 
            } catch (BrokenBarrierException ex) { 
            }

            try {
                Thread.sleep(generator.nextInt(30)+1);
            } catch (InterruptedException ex) { 
            }
            assemble();

            try {
                used.await();
            } catch (InterruptedException ex) { 
            } catch (BrokenBarrierException ex) { 
            }
        }
    }

    public void assemble() {
        synchronized (System.out) {
            System.out.println("Assemble!");
        }
    }

}
