import java.util.concurrent.BrokenBarrierException;
import java.util.concurrent.CyclicBarrier;
import java.util.Random;

public class User implements Runnable {

    private CyclicBarrier waitForIt;
    private CyclicBarrier acquire;
    private CyclicBarrier release;
    private String        name;
    private Random        generator = new Random();

    public User(String        name,
                CyclicBarrier waitForIt,
                CyclicBarrier acquire,
                CyclicBarrier release) {
        this.name      = name;
        this.waitForIt = waitForIt;
        this.acquire   = acquire;
        this.release   = release;
    }

    public void run() {
        try {
            waitForIt.await(); 
        } catch (InterruptedException ex) { 
        } catch (BrokenBarrierException ex) { 
        }

        while (true) {
            try {
                Thread.sleep(generator.nextInt(30)+1);
            } catch (InterruptedException ex) { 
            }

            try {
                acquire.await();
            } catch (InterruptedException ex) { 
            } catch (BrokenBarrierException ex) { 
            }

            System.out.println(name + ".Acquired!");

            use();

            try {
                release.await();
            } catch (InterruptedException ex) { 
            } catch (BrokenBarrierException ex) { 
            }

            System.out.println(name + ".Released!");
        }
    }

    public void use() {
        synchronized (System.out) {
            System.out.println(name + ".Use!");
        }
    }

}
